/*
  Basic ESP32 MQTT
  ESP32_mqtt_espA25_fern
  ESP32_pylontech_mqtt_V10 platine2
  board DOIT ESP32 DEVKIT V1
*/
#include <WiFi.h>
#include <PubSubClient.h>

// Update these with values suitable for your network.
const char* ssid = "MYNETWORK";
const char* password = "mypasswd";
const char* mqtt_server = "192.168.xxx.xxx";

WiFiClient espClient;
PubSubClient client(espClient);
//mqtt_client = mqtt.Client(1, 120, nil, nil, 1, 1536)
long lastMsg = 0;
char msg[2500];
const char* topicpy = "pylon2c";
char py_msg[150];
char kzeile[ ] = "                                                                ";
int value = 0;
int packetSize =0;
//int LED_BUILTIN = 2;
//int BUILTIN_LED = 2;
#define RXD2 16
#define TXD2 17

#define E131_BUFFER_SIZE 2500
//#define MQTT_BUF_SIZE 2500  in in PubSubClient.h ändern

byte E131Buffer[E131_BUFFER_SIZE];
String pzeile = "  ";
String py_zeile = " ";
int py_buffer =0;
int py_auto_2 =0;

char incomingByte = 0;
int pyp = 0;
int cmd_p = 0;
volatile int pos =0;
unsigned int msgLength = 0;


void init_pylon() {
  Serial.println("start init_pylon2");
  byte cmd[] = {0x7E, 0x32, 0x30, 0x30, 0x31, 0x34, 0x36, 0x38, 0x32, 0x43, 0x30, 0x30, 0x34, 0x38, 0x35, 0x32, 0x30, 0x46, 0x43, 0x43, 0x33, 0x0D};
  Serial2.write(cmd, sizeof(cmd));
  delay(1000);
  Serial.println("ende init_pylon2");
}

void setup() {
  pinMode(BUILTIN_LED, OUTPUT);     // Initialize the BUILTIN_LED pin as an output
  Serial.begin(115200);

  setup_wifi();
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);

  Serial2.begin(1200, SERIAL_8N1, RXD2, TXD2);
  init_pylon();
  Serial2.flush();
  Serial2.end();
  Serial2.begin(115200, SERIAL_8N1, RXD2, TXD2);
  Serial2.setRxBufferSize(4096);
  byte cmd[] = {0x0A, 0x0A};
  Serial2.write(cmd, sizeof(cmd));
  //Serial2.println("\n\n\nConnecting to pylon init ist umgeschaltet");
  Serial.println("\n\n\nConnecting to pylon2 init ist umgeschaltet");

  //Versionspflege
  Serial.println("ESP32_pylontech_mqtt_V10\n");

  Serial.println("Menü (h)");
  Serial.println("i Informationen ");
  Serial.println("p Power ");
  Serial.println("x Remote off ");
  Serial.println("z Reset erzwingen ");
  Serial.println("b battery ");
  Serial.println("s statistics ");
  Serial2.println("help\n");
}

void setup_wifi() {
  delay(10);
  // We start by connecting to a WiFi network
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(800);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}

void callback(char* topic, byte* payload, unsigned int length) {
  Serial.print("Message arrived [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i = 0; i < length; i++) {
    Serial.print((char)payload[i]);
  }
  Serial.println();
  // Switch on the LED if an 1 was received as first character
  if ((char)payload[0] == '1') {
    digitalWrite(BUILTIN_LED, LOW);   // Turn the LED on (Note that LOW is the voltage level
    // but actually the LED is on; this is because
    // it is acive low on the ESP-01)
  } else {
    digitalWrite(BUILTIN_LED, HIGH);  // Turn the LED off by making the voltage HIGH
  }

}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print("Attempting MQTT connection...");
    // Attempt to connect
    //################################################################
    // eindeutiger Client-Name für jedes NodeMCU-Modul verwenden.
    // steht im mosquitto-broker log  /var/log/mosquitto/mosquitto.log
    //################################################################
    if (client.connect("ESP32-PYLON-10")) {
      Serial.println("connected");
      // Once connected, publish an announcement...
      client.publish("outTopic", "hello world");
      // ... and resubscribe
      client.subscribe("inTopic");
      //client.subscribe("pylon2#"); // problem mit #
    } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}

void pylon_read() {
  while (Serial2.available()) {
    int packetSize = Serial2.readBytes(E131Buffer, E131_BUFFER_SIZE);
    Serial.write(E131Buffer, E131_BUFFER_SIZE);
    //Serial2.write(E131Buffer, E131_BUFFER_SIZE);
    char *kzeile = (char *) E131Buffer;  // conversion from a byte array to a character array
    snprintf (msg, E131_BUFFER_SIZE, kzeile); //--> aktuelle ausgabe
    client.publish(topicpy, msg);
    topicpy = "pylon2c";
  }
}


void loop() {

  if (!client.connected()) {
    reconnect();
  }
  client.loop();

  while (Serial2.available()) {
    int packetSize = Serial2.readBytes(E131Buffer, E131_BUFFER_SIZE);
    Serial.write(E131Buffer, E131_BUFFER_SIZE);
    char *kzeile = (char *) E131Buffer;  // conversion from a byte array to a character array
    for (int i = 0; i < E131_BUFFER_SIZE; i++) {
         if (kzeile[i] == 0x24)  {
          py_buffer = i;
          i = E131_BUFFER_SIZE;
        }
        if (kzeile[i] == 0x25)  {
          kzeile[i] = 0x50;
         } 
     }
    snprintf (msg, py_buffer, kzeile); //--> aktuelle ausgabe
    client.publish(topicpy, msg);
  }

  if (Serial.available() > 0)   //Tasteneingaben
  {
    incomingByte = Serial.read();
    if (incomingByte == 'h')
    {
      Serial.println("Menü (h)");
      Serial.println("i Informationen ");
      Serial.println("p Power ");
      Serial.println("x Remote off ");
      Serial.println("z Reset erzwingen ");
      Serial.println("b battery ");
      Serial.println("s statistics ");
      Serial.println("l log ");
      snprintf (msg, 50, "h Menü");
      topicpy = "pylon2h";
      client.publish(topicpy, msg);
    }
    if (incomingByte == 'z')
    {
      //software_Reset() ;
      snprintf (msg, 50, "z Reset erzwingen");
      topicpy = "pylon2r";
      client.publish(topicpy, msg);
      Serial.println("Restarting in 3 seconds");
      delay(3000);
      ESP.restart();
    }
    if (incomingByte == 'i')
    {
      Serial.println("\n i Informationen\n");
      snprintf (msg, 50, "i Informationen");
      topicpy = "pylon2i";
      client.publish(topicpy, msg);
      Serial2.print("info\n");
    }

    if (incomingByte == 'p')
    {
      Serial.println("\np Power\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylon2p";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (incomingByte == 'x')
    {
      Serial.println("\nx Remote off\n");
      snprintf (msg, 50, "x Remote off");
      topicpy = "pylon2x";
      client.publish(topicpy, msg);
      py_auto_2 =26;
    }
    if (incomingByte == 's')
    {
      Serial.println("s statistics");
      snprintf (msg, 50, "s statistics");
      topicpy = "pylon2s";
      client.publish(topicpy, msg);
      Serial2.print("stat 2\n");
    }
    if (incomingByte == 'b')
    {
      Serial.println("b battery");
      snprintf (msg, 50, "b battery");
      topicpy = "pylon2b";
      client.publish(topicpy, msg);
      Serial2.print("bat\n");
    }
    if (incomingByte == 'l')
    {
      Serial.println("l log");
      snprintf (msg, 50, "l log");
      topicpy = "pylon2l";
      client.publish(topicpy, msg);
      Serial2.print("log\n");
    }
    Serial.flush();
  } // Ende Serial.available() > 0 ende Tasteneingaben


  long now = millis();
  if (now - lastMsg > 5000) {
    lastMsg = now;
    if (py_auto_2 == 1) {
      Serial.println("\np Power automatik\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylonp";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (py_auto_2 == 2) {
      Serial.println("b battery1");
      snprintf (msg, 50, "b battery1");
      topicpy = "pylon1b";
      client.publish(topicpy, msg);
      Serial2.print("bat 1\n");
    }
    if (py_auto_2 == 3) {
      Serial.println("s statistik1");
      snprintf (msg, 50, "s statistik1");
      topicpy = "pylon1s";
      client.publish(topicpy, msg);
      Serial2.print("stat 1\n");
    }
    if (py_auto_2 == 4) {
      Serial.println("\np Power automatik\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylonp";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (py_auto_2 == 5) {
      Serial.println("b battery2");
      snprintf (msg, 50, "b battery2");
      topicpy = "pylon2b";
      client.publish(topicpy, msg);
      Serial2.print("bat 2\n");
    }
    if (py_auto_2 == 6) {
      Serial.println("s statistik2");
      snprintf (msg, 50, "s statistik2");
      topicpy = "pylon2s";
      client.publish(topicpy, msg);
      Serial2.print("stat 2\n");
    }
    if (py_auto_2 == 7) {
      Serial.println("\np Power automatik\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylonp";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (py_auto_2 == 8) {
      Serial.println("b battery3");
      snprintf (msg, 50, "b battery3");
      topicpy = "pylon3b";
      client.publish(topicpy, msg);
      Serial2.print("bat 3\n");
    }
    if (py_auto_2 == 9) {
      Serial.println("s statistik3");
      snprintf (msg, 50, "s statistik3");
      topicpy = "pylon3s";
      client.publish(topicpy, msg);
      Serial2.print("stat 3\n");
    }
    if (py_auto_2 == 10) {
      Serial.println("\np Power automatik\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylonp";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (py_auto_2 == 11) {
      Serial.println("b battery4");
      snprintf (msg, 50, "b battery4");
      topicpy = "pylon4b";
      client.publish(topicpy, msg);
      Serial2.print("bat 4\n");
    }
    if (py_auto_2 == 12) {
      Serial.println("s statistik4");
      snprintf (msg, 50, "s statistik4");
      topicpy = "pylon4s";
      client.publish(topicpy, msg);
      Serial2.print("stat 4\n");
    } 
    if (py_auto_2 == 13) {
      Serial.println("\np Power automatik\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylonp";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (py_auto_2 == 14) {
      Serial.println("b battery5");
      snprintf (msg, 50, "b battery5");
      topicpy = "pylon5b";
      client.publish(topicpy, msg);
      Serial2.print("bat 5\n");
    }
    if (py_auto_2 == 15) {
      Serial.println("s statistik5");
      snprintf (msg, 50, "s statistik5");
      topicpy = "pylon5s";
      client.publish(topicpy, msg);
      Serial2.print("stat 5\n");
    }
    if (py_auto_2 == 16) {
      Serial.println("\np Power automatik\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylonp";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (py_auto_2 == 17) {
      Serial.println("b battery6");
      snprintf (msg, 50, "b battery6");
      topicpy = "pylon6b";
      client.publish(topicpy, msg);
      Serial2.print("bat 6\n");
    }
    if (py_auto_2 == 18) {
      Serial.println("s statistik6");
      snprintf (msg, 50, "s statistik6");
      topicpy = "pylon6s";
      client.publish(topicpy, msg);
      Serial2.print("stat 6\n");
    }
    if (py_auto_2 == 19) {
      Serial.println("\np Power automatik\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylonp";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (py_auto_2 == 20) {
      Serial.println("b battery7");
      snprintf (msg, 50, "b battery7");
      topicpy = "pylon7b";
      client.publish(topicpy, msg);
      Serial2.print("bat 7\n");
    }
    if (py_auto_2 == 21) {
      Serial.println("s statistik7");
      snprintf (msg, 50, "s statistik7");
      topicpy = "pylon7s";
      client.publish(topicpy, msg);
      Serial2.print("stat 7\n");
    }
    if (py_auto_2 == 22) {
      Serial.println("\np Power automatik\n");
      snprintf (msg, 50, "p Power");
      topicpy = "pylonp";
      client.publish(topicpy, msg);
      Serial2.print("pwr\n");
    }
    if (py_auto_2 == 23) {
      Serial.println("b battery8");
      snprintf (msg, 50, "b battery8");
      topicpy = "pylon8b";
      client.publish(topicpy, msg);
      Serial2.print("bat 8\n");
    }
    if (py_auto_2 == 24) {
      Serial.println("s statistik8");
      snprintf (msg, 50, "s statistik8");
      topicpy = "pylon8s";
      client.publish(topicpy, msg);
      Serial2.print("stat 8\n");
    } 
    if (py_auto_2 == 25) {
      Serial.println("i info");
      snprintf (msg, 50, "i info");
      topicpy = "pyloni";
      client.publish(topicpy, msg);
      Serial2.print("info\n");
      py_auto_2 =0;
    }
    py_auto_2++;
    if (py_auto_2 > 80) py_auto_2 =0;  // automatik wieder einschalten
    Serial.print("Publish message loop: (letzte gesendete)  py_auto_2 = ");
    Serial.println(py_auto_2);
  }
}  // Ende void loop()
